package org.dive4elements.river.exports.injector;

import org.apache.log4j.Logger;
import org.dive4elements.artifacts.Artifact;
import org.dive4elements.artifacts.CallContext;
import org.dive4elements.artifacts.ContextInjector;
import org.dive4elements.river.artifacts.D4EArtifact;
import org.dive4elements.river.artifacts.access.HistoricalDischargeAccess;
import org.dive4elements.river.model.Gauge;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

import static org.dive4elements.river.exports.injector.InjectorConstants.CURRENT_KM;

public class HistoricalDischargeInjector
implements ContextInjector
{
    private static Logger log =
        Logger.getLogger(HistoricalDischargeInjector.class);

    @Override
    public void setup(Element cfg) {

    }

    @Override
    public void injectContext(
        CallContext ctx,
        Artifact artifact,
        Document request
    ) {
        HistoricalDischargeAccess access =
            new HistoricalDischargeAccess((D4EArtifact)artifact);
        Long gaugeNumber = access.getOfficialGaugeNumber();
        if (gaugeNumber == null) {
            return;
        }
        Gauge gauge = Gauge.getGaugeByOfficialNumber(gaugeNumber);
        if (gauge == null) {
            return;
        }
        double km = gauge.getStation().doubleValue();
        ctx.putContextValue(CURRENT_KM, km);
    }
}
